Type TBanSystem
	Const BAN_FILE:String = "BanList.dat"
	
	Global BanList:String[]
	
	Function Init()
		LoadBanList()
	End Function
	
	Function LoadBanList()
		Local Instream:TStream = ReadFile( BAN_FILE )
		
		If Instream Then
			While Not Instream.Eof()
				Local Host:String = Instream.ReadLine()
				
				BanList :+ [ Host ]
			Wend
			
			Instream.Close()
		EndIf
	End Function
	
	Function SaveBanList()
		Local Outstream:TStream = WriteFile( BAN_FILE )
		
		If Outstream Then
			For Local Ban:String = EachIn BanList
				Outstream.WriteLine( Ban )
			Next
			
			Outstream.Close()
		EndIf
	End Function
	
	Function AddBan( Player:TPlayer )
		BanList :+ [ Player.Peer.Address.ToString() ]
		
		SaveBanList()
	End Function
	
	Function AddBanHost( Host:String )
		BanList :+ [ Host ]
		
		SaveBanList()
	End Function
	
	Function RemoveBan( Host:String )
		For Local I:Int = 0 Until BanList.Length
			If BanList[ I ].ToLower() = Host Then
				BanList = BanList[ .. I ] + BanList[ I + 1 .. ]
				
				SaveBanList()
				
				Return
			EndIf
		Next
	End Function
	
	Function PlayerBanned:Int( Player:TPlayer )
		For Local I:String = EachIn BanList
			If I.ToLower() = Player.Peer.Address.ToString().ToLower() Then Return True
		Next
	End Function
End Type