Type TPlayer
	Global Players:TList = New TList
	
	Field Name:String
	Field Peer:TENetPeer
	Field ID:Int
	
	Field Ping:Int
	Field PingTimer:Int
	
	Field X:Float
	Field Y:Float
	Field Z:Float
	
	Field RotX:Float
	Field RotY:Float
	
	Field Input:Int
	Field Godmode:Int
	Field Crouching:Int
	
	Field IsAdmin:Int
	Field IsRegistered:Int
	
	Method New()
		Players.AddLast( Self )
	End Method
	
	Method Remove()
		Players.Remove( Self )
	End Method
	
	Method SetName( Name:String )
		Self.Name = Name
	End Method
	
	Method SetPing( Ping:Int, Timer:Int )
		Self.Ping = Ping
		Self.PingTimer = Timer
	End Method
	
	Method SetCoordinates( X:Float, Y:Float, Z:Float, RotX:Float, RotY:Float )
		Self.X = X
		Self.Y = Y
		Self.Z = Z
		Self.RotX = RotX
		Self.RotY = RotY
	End Method
	
	Method SetInput( Input:Int )
		Self.Input = Input
	End Method
	
	Method SetGodmode( Godmode:Int )
		Self.Godmode = Godmode
	End Method
	
	Method SetCrouching( Mode:Int )
		Self.Crouching = Mode
	End Method
	
	Function Create:TPlayer( Peer:TENetPeer )
		Local Player:TPlayer = New TPlayer
		
		Player.Peer = Peer
		Player.ID   = PointerToInt( Peer.Original )
		
		Return Player
	End Function
	
	Function FindPlayerByID:TPlayer( ID:Int )
		For Local Player:TPlayer = EachIn Players
			If Player.ID = ID Then Return Player
		Next
		
		Return Null
	End Function
	
	Function FindPlayerByName:TPlayer( Name:String )
		For Local Player:TPlayer = EachIn Players
			If Player.Name.ToLower() = Name.ToLower() Then Return Player
		Next
		
		Return Null
	End Function
	
	Function PointerToInt:Int( Pointer:Byte Ptr )
		Return ( Int Ptr ( Varptr Pointer ) )[ 0 ]
	End Function
End Type
